#if !defined _LIBHF_HEADER_H_
#define _LIBHF_HEADER_H_

#include <math.h>

#if defined IBM_INTEL_NT
#define M_IMPORT  __declspec(dllimport)
#define M_CALL  __stdcall
#else
#define M_IMPORT
#define M_CALL
#endif

/* define which math functions to use, the system functions, or our own */

/* TRIG functions */
#if defined APPLE_OSX || defined HP_RISC_UNIX || \
    defined IBM_INTEL_LINUX || defined IBM_RISC_UNIX || \
    defined SGI_MIPS_UNIX || defined IBM_INTEL_NT || \
    defined SUN_SPARC_UNIX || defined HP_RISC_HPUX9 || \
    defined IBM_INTEL_LINUX22
#undef _HFTRIG
#define _HFTRIG
extern double M_CALL hftrig( double x, int t );
#define hfsin(x)	hftrig(x,1)
#define hfcos(x)	hftrig(x,0)
#define hftan(x)	(hftrig(x,1)/hftrig(x,0))
#else
#define hfsin		sin
#define hfcos		cos
#define hftan		tan
#endif  /* TRIG functions */

/* LOG function */
#if defined APPLE_OSX || defined HP_RISC_HPUX9 || \
    defined SUN_SPARC_UNIX
#undef _HFLOG
#define _HFLOG
extern double M_CALL hflog( double x );
#else
#define hflog		log
#endif  /* LOG function */

/* EXP function */
#if defined IBM_INTEL_NT || defined HP_RISC_HPUX9 || \
    defined HP_RISC_UNIX || defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_LINUX22 || defined SUN_SPARC_UNIX
#undef _HFEXP
#define _HFEXP
extern double M_CALL hfexp( double x );
#else
#define hfexp		exp
#endif  /* EXP function */

/* LOGB function */
#if defined IBM_INTEL_LINUX || defined IBM_RISC_UNIX || \
    defined IBM_INTEL_NT || \
    defined SUN_SPARC_UNIX || defined HP_RISC_HPUX9 || \
    defined IBM_INTEL_LINUX22
#undef _HFLOGB
#define _HFLOGB
extern int M_CALL hflogb( double x );
extern double M_CALL hfscalbn( double x, int n );
#else
#define hflogb		logb
#define hfscalbn	scalbn
#endif  /* LOGB function */

/* ERF function */
#if defined DEC_ALPHA_UNIX || \
    defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_NT || \
    defined SUN_SPARC_UNIX || \
    defined IBM_INTEL_LINUX22
#undef _HFERF
#define _HFERF
extern double M_CALL hferf( double x );
#else
#define hferf		erf
#endif  /* ERF function */

/* ERFC function */
#if defined HP_RISC_UNIX || \
    defined IBM_INTEL_LINUX || defined IBM_RISC_UNIX || \
    defined SGI_MIPS_UNIX || defined IBM_INTEL_NT || \
    defined HP_RISC_HPUX9 || defined IBM_INTEL_LINUX22
#undef _HFERFC
#define _HFERFC
extern double M_CALL hferfc( double x );
#else
#define hferfc		erfc
#endif  /* ERFC function */

/* LGAMMA function */
#if defined APPLE_OSX || \
    defined IBM_INTEL_LINUX || defined HP_RISC_UNIX || \
    defined SGI_MIPS_UNIX || defined IBM_INTEL_NT || \
    defined HP_RISC_HPUX9 || defined IBM_INTEL_LINUX22 || \
    defined SUN_SPARC_UNIX
#undef _HFLGAMMA
#define _HFLGAMMA
extern double M_CALL hflgamma( double x );
extern M_IMPORT int M_CALL hfsigngam;
#else
extern int signgam;
#define hflgamma    	lgamma
#define hfsigngam	signgam
#endif  /* LGAMMA function */

/* SINH function */
#if defined APPLE_OSX || defined HP_RISC_UNIX || \
    defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_NT || \
    defined HP_RISC_HPUX9 || \
    defined IBM_INTEL_LINUX22
#undef _HFSINH
#define _HFSINH
extern double M_CALL hfsinh( double x );
#else
#define hfsinh		sinh
#endif  /* _HFSINH */

/* COSH function */
#if defined APPLE_OSX || defined HP_RISC_UNIX || \
    defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_NT || \
    defined HP_RISC_HPUX9 || \
    defined IBM_INTEL_LINUX22
#undef _HFCOSH
#define _HFCOSH
extern double M_CALL hfcosh( double x );
#else
#define hfcosh		cosh
#endif  /* COSH function */

/* TANH function */
#if defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_NT || \
    defined APPLE_OSX || \
    defined IBM_INTEL_LINUX22
#undef _HFTANH
#define _HFTANH
extern double M_CALL hftanh( double x );
#else
#define hftanh		tanh
#endif  /* TANH function */

/* ASIN function */
#if 0
#define _HFASIN
extern double hfasin();
#else
#define hfasin		asin
#endif  /* _HFASIN */

/* ACOS function */
#if 0
#undef _HFACOS
#define _HFACOS
extern double hfacos( double x );
#else
#define hfacos		acos
#endif  /* ACOS function */

/* ATAN function */
#if defined IBM_INTEL_LINUX || \
    defined IBM_INTEL_LINUX22
#undef _HFATAN
#define _HFATAN
extern double M_CALL hfatan( double x );
#else
#define hfatan		atan
#endif  /* ATAN function */

/* ASINH function */
#if defined IBM_INTEL_LINUX || defined IBM_INTEL_NT || \
    defined IBM_INTEL_LINUX22
#undef _HFASINH
#define _HFASINH
extern double M_CALL hfasinh( double x );
#else
#define hfasinh		asinh
#endif  /* ASINH funciton */

/* ACOSH function */
#if defined IBM_INTEL_NT
#undef _HFACOSH
#define _HFACOSH
extern double M_CALL hfacosh( double x );
#else
#define hfacosh		acosh
#endif  /* ACOSH function */

/* ATANH function */
#if defined IBM_INTEL_LINUX || defined IBM_INTEL_NT || \
    defined IBM_INTEL_LINUX22
#undef _HFATANH
#define _HFATANH
extern double M_CALL hfatanh( double x );
#else
#define hfatanh		atanh
#endif  /* ATANH function */

#ifndef _NO_COMPLEX_FUNCTIONS

/* include the kernel exported functions */

/* ------------------------ */
/*  Unary Float Functions   */
/* ------------------------ */

#include "mplshlib.h"

ComplexFloat64 M_IMPORT hfu_GAMMA( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_lnGAMMA( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_Im( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_Re( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_tan( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_sin( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_cos( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_abs( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccsc( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccsch( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arcsec( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arcsech( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_sec( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_sech( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_ceil( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_Integer( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_length( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_Dirac( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_ln( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_floor( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_signum( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arcsin( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arcsinh( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arctan( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arctanh( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_cot( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_coth( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_log( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_log10( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_round( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_sqrt( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_factorial( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_trunc( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_frac( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccos( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccosh( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_csc( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_csch( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_csgn( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_Heaviside( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccot( ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfu_arccoth( ComplexFloat64 r );

/* ------------------------ */
/*  Binary Float Functions   */
/* ------------------------ */

ComplexFloat64 M_IMPORT hfb_Float( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_arctan( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_signum( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_csgn( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_abs( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_floor( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_ceil( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_round( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_trunc( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_frac( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_Dirac( ComplexFloat64 q, ComplexFloat64 r );
ComplexFloat64 M_IMPORT hfb_binomial( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_iquo( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_irem( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_modp( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_mods( ComplexFloat64 r, ComplexFloat64 q );
ComplexFloat64 M_IMPORT hfb_surd( ComplexFloat64 r, ComplexFloat64 q );

#else

#include "mtypes.h"

#endif

#ifdef __cplusplus
extern "C" {
#endif

#if defined DEC_ALPHA_UNIX
#include <fp_class.h>
#define MIsPosInfinity(x)       (fp_class(x) == FP_POS_INF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fp_class(x) == FP_NEG_INF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fp_class(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fp_class(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsPosZero(x)          (fp_class(x) == FP_POS_ZERO)
#define MIsPosZeroDef
#define MIsNegZero(x)          (fp_class(x) == FP_NEG_ZERO)
#define MIsNegZeroDef
#define MIsDenormal(x)          (fp_class(x) == FP_POS_DENORM || \
				 fp_class(x) == FP_NEG_DENORM)
#define MFPClass(x)             fp_class(x)
#endif

#if defined SUN_SPARC_UNIX
#include <floatingpoint.h>
#define MIsPosInfinity(x)       (isinf(x) && !signbit(x))
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (isinf(x) && signbit(x))
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fp_class(x) == fp_quiet)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fp_class(x) == fp_signaling)
#define MIsSignalNaNDef
#define MIsDenormal(x)          (fp_class(x) == fp_subnormal)
#define MFPClass(x)             fp_class(x)
#endif

#if defined SUN_SPARC_SOL23 || \
    defined SUN_SPARC_SOLARIS || \
    defined IBM_INTEL_SOLARIS
#include <ieeefp.h>
#define MIsPosInfinity(x)       (fpclass(x) == FP_PINF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fpclass(x) == FP_NINF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fpclass(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fpclass(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsPosZero(x)          (fpclass(x) == FP_PZERO)
#define MIsPosZeroDef
#define MIsNegZero(x)          (fpclass(x) == FP_NZERO)
#define MIsNegZeroDef
#define MIsDenormal(x)          (fpclass(x) == FP_PDENORM || \
				 fpclass(x) == FP_NDENORM)
#define MFPClass(x)             fpclass(x)
#endif

#if defined SGI_MIPS_UNIX
#include <fp_class.h>
#define MIsPosInfinity(x)       (fp_class_d(x) == FP_POS_INF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fp_class_d(x) == FP_NEG_INF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fp_class_d(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fp_class_d(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsDenormal(x)          (fp_class_d(x) == FP_POS_DENORM || \
				 fp_class_d(x) == FP_NEG_DENORM)
#define MFPClass(x)             fp_class_d(x)
#endif

#if defined HP_RISC_HPUX10_2 || defined HP_RISC_HPUX9
#define MIsPosInfinity(x)       (fpclassify(x) == FP_PLUS_INF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fpclassify(x) == FP_MINUS_INF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fpclassify(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fpclassify(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsDenormal(x)          (fpclassify(x) == FP_PLUS_DENORM || \
				 fpclassify(x) == FP_MINUS_DENORM)
#define MFPClass(x)             fpclassify(x)
#endif

#if defined HP_RISC_UNIX 
#define MIsPosInfinity(x)       (fpclassify(x) == FP_INFINITE && !signbit(x))
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fpclassify(x) == FP_INFINITE && signbit(x))
#define MIsNegInfinityDef
#define MIsDenormal(x)          (fpclassify(x) == FP_SUBNORMAL)
#define MFPClass(x)             fpclassify(x)
#endif

#if defined IBM_RISC_UNIX
#include <float.h>
#define MIsPosInfinity(x)       (class(x) == FP_PLUS_INF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (class(x) == FP_MINUS_INF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (class(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (class(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsPosZero(s)          (class(s) == FP_PLUS_ZERO)
#define MIsPosZeroDef
#define MIsNegZero(s)          (class(s) == FP_MINUS_ZERO)
#define MIsNegZeroDef
#define MIsDenormal(x)          (class(x) == FP_PLUS_DENORM || \
				 class(x) == FP_MINUS_DENORM)
#define MFPClass(x)             class(x)
/* Gee, I hope IBM never wants to support C++. */
#endif

#if defined WMI_WINNT && !defined __WATCOMC__
#include <float.h>
#define MIsPosInfinity(x)       (_fpclass(x) == _FPCLASS_PINF)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (_fpclass(x) == _FPCLASS_NINF)
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (_fpclass(x) == _FPCLASS_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (_fpclass(x) == _FPCLASS_SNAN || \
					_fpclass(x) == _FPCLASS_QNAN)
#define MIsSignalNaNDef
#define MIsPosZero(s)          (_fpclass(s) == _FPCLASS_PZ)
#define MIsPosZeroDef
#define MIsNegZero(s)          (_fpclass(s) == _FPCLASS_NZ)
#define MIsNegZeroDef
#define MIsDenormal(x)          (_fpclass(x) == _FPCLASS_PD|| \
				 _fpclass(x) == _FPCLASS_ND)
#define MFPClass(x)             _fpclass(x)
#endif

#if defined IBM_INTEL_LINUX
#include <math.h>
#define MIsPosInfinity(x)       (isinf(x)==1)
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (isinf(x)==-1)
#define MIsNegInfinityDef
#define MIsInfinity(x)          (isinf(x))
#define MIsInfinityDef
#define MIsNotANumber(x)        (isnan(x))
#define MIsNotANumberDef
#endif

#ifdef APPLE_PPC_MAC
#include <fp.h>
#define MIsPosInfinity(x)       (fpclassify(x) == FP_INFINITE && signbit(x) == 0 )
#define MIsPosInfinityDef
#define MIsNegInfinity(x)       (fpclassify(x) == FP_INFINITE && signbit(x) != 0 )
#define MIsNegInfinityDef
#define MIsQuietNaN(x)          (fpclassify(x) == FP_QNAN)
#define MIsQuietNaNDef
#define MIsSignalNaN(x)         (fpclassify(x) == FP_SNAN)
#define MIsSignalNaNDef
#define MIsDenormal(x)          (fpclassify(x) == FP_SUBNORMAL)
#define MFPClass(x)             fpclassify(x)
#endif

/* Default definitions for platforms that don't have (good) support for this
 * in their libraries. */
#ifndef MIsPosInfinityDef
extern M_BOOL MIsPosInfinity( double x );
#endif

#ifndef MIsNegInfinityDef
extern M_BOOL MIsNegInfinity( double x );
#endif

#ifndef MIsInfinityDef
#  define MIsInfinity(x)          (MIsPosInfinity(x) || MIsNegInfinity(x))
#endif

#ifndef MIsQuietNaNDef
extern M_BOOL MIsQuietNaN( double x );
#endif

#ifndef MIsSignalNaNDef
extern M_BOOL MIsSignalNaN( double x );
#endif

#ifndef MIsNotANumberDef
#  define MIsNotANumber(x)        (MIsQuietNaN(x) || MIsSignalNaN(x))
#endif

#ifndef MIsPosZeroDef
extern M_BOOL MIsPosZero( double x );
#endif

#ifndef MIsNegZeroDef
extern M_BOOL MIsNegZero( double x );
#endif

#ifndef MIsZeroDef
# ifdef _MSC_VER
#  define MIsZero(x)            (MIsPosZero(x) || MIsNegZero(x))
# else
#  define MIsZero(x)            ((x) == 0.0)
# endif
#endif

/* These must be initialized by a call to InitializeIEEEMath. */
    
extern M_IMPORT double mIEEEPosInfinity;
extern M_IMPORT double mIEEENegInfinity;
extern M_IMPORT double mIEEEQuietNaN;
extern M_IMPORT double mIEEESignalNaN;
extern M_IMPORT double mIEEECatalan;
extern M_IMPORT double mIEEEPi;
extern M_IMPORT double mIEEEgamma;

#ifndef MIsDenormal
#define MIsDenormal(x)    ((x)<0 ? (x) > -DBL_MIN : ((x)>0 ? (x) < DBL_MIN : 0))
#endif
#ifndef MFPClass
#define MFPClass(x)             0
#endif

extern void InitializeIEEEMath( void );
extern void M_DECL DisableFPUExceptions( void );
extern void RestoreFPUExceptions( void );

#ifdef __cplusplus
}
#endif

#endif
